(* Title:  "MathengineBasic/problem.sml"
   Author: Walther Neuper
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- rebuild fun Outer_Syntax.command \<^command_keyword>\<open>problem\<close> ------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";

"----------- rebuild fun Outer_Syntax.command \<^command_keyword>\<open>problem\<close> ------------------------";
"----------- rebuild fun Outer_Syntax.command \<^command_keyword>\<open>problem\<close> ------------------------";
"----------- rebuild fun Outer_Syntax.command \<^command_keyword>\<open>problem\<close> ------------------------";
val drop_pos_model = (fn (a, b, _) => (a, b))
val drop_pos_where_ = (fn (b, _) => b);

"~~~~~ fun Outer_Syntax.command \<^command_keyword>\<open>problem\<close> , args:"; val () = ();
(*for problem pbl_equ_univ_lin : "LINEAR/univariate/equation"*)
val thy = @{theory LinEq}
val ctxt = Proof_Context.init_global thy;
val model_input = (*type Position.T is hidden, thus redefinition*)
 [("#Given", (*-------------------------------vv=-3727*)
   [("equality e_e", Position.none), 
    ("solveFor v_v", Position.none)]),
  ("#Where",
   [("HOL.False", Position.none),
    ("Not( (lhs e_e) is_polyrat_in v_v)", Position.none), 
    ("Not( (rhs e_e) is_polyrat_in v_v)", Position.none),
    ("((lhs e_e) has_degree_in v_v)=1", Position.none),
    ("((rhs e_e) has_degree_in v_v)=1", Position.none)]),
  ("#Find",
   [("solutions v_v'i'", Position.none)])]: (Model_Pattern.m_field * (string * Position.T) list) list

            val (model, where_) = Model_Pattern.parse_pos ctxt model_input;

(* ARGUMENTS DEFINED BELOW:
           prep_store thy name maa id_empty
              (model, where_, cas) (pbl_id, met_ids, where_rls); *)
"~~~~~ fun prep_store , args:"; val (thy, name, maa, start_refine,
    (model, where_, cas), (pbl_id, met_ids, where_rls)) =
  (@{theory LinEq}, "pbl_equ_univ_lin", [""], Problem.id_empty,
    (model, where_, NONE: term option), (Problem.id_empty, [MethodC.id_empty], Rule_Set.empty));
(*for problem pbl_equ_univ_lin : "LINEAR/univariate/equation"*)

            val (model, where_) = Model_Pattern.parse_pos ctxt model_input
            val (model', where_') = (map drop_pos_model model, map drop_pos_where_ where_)

            val arg = Problem.prep_store thy name maa Problem.id_empty
              (model', where_', cas) (pbl_id, met_ids, where_rls)
